; Program za 32-bitno dijeljenje metodom pomaka, verzija 2

	AREA div_32_v2, CODE, READONLY
	
	ENTRY

ADDR EQU 0x8100			; adresa na kojoj se nalaze podatci
	
	MOV R4, #ADDR   	; postavlja registar R4 adresu podataka
	LDR R5, [R4], #4	; djeljenik (A) se ucitava u R5
	LDR R6, [R4], #4	; djelitelj (B) se ucitava u R6
	MOV R7, #0			; cisti se registar za spremanje
								; rezultata (R7)
	MOV R8, #0			; brojac pomaka
	CMP R6, R5			; ako B>A nema potrebe za dijeljenjem
	BHI KRAJ
	
PORAVNAJ			;dijeljenje pomakom dok brojevi nisu usporedivi
	
	MOVS R3, R6, LSR #31 	; provjerava je li MSB djelitelja
								; jednak 1
	BNE DIV					; ako je, poravnavanje je nepotrebno
	CMP R5, R6, LSL #1	; provjerava je li A >= 2*B
	MOVHS R6, R6, LSL #1	; ako je pomice B ulijevo
	ADDHS R8, R8, #1	; povecava brojac pomaka
	BHI PORAVNAJ		; samo ako je A>2*B postupak 
								; poravnavanja se nastavlja
	
DIV	
	CMP R5, R6			; usporedjuje trenutacni ostatak i B
	SUBHS R5, R5, R6	; ako ostatak >= B onda ga umanji za B
	ADDHS R7, R7, #1	; i poveca rezultat za 1
	CMP R8, #0			; ako je brojac pomaka > 0
	MOVHI R6, R6, LSR #1	; pomakne B udesno
	MOVHI R7, R7, LSL #1	; a rezultat ulijevo
	SUBHI R8, R8, #1	; umanji brojac pomaka
	BHI DIV					; i ponovi petlju
	
KRAJ
	STR R5, [R4], #4	; spremanje ostatka
	STR R7, [R4]		; spremanje rezultata	

	MOV R0, #0x18		; angel_SWIreason_ReportException
	LDR R1, =0x20026	; ADP_Stopped_ApplicationExit
	SWI 0x123456 		; ARM semihosting SWI		
	END

