; Program za pretvorbu ASCII zapisa hex broja u broj 
; koristenjem potprograma, verzija 1

	AREA atoh_v1, CODE, READONLY
		ENTRY
	
ADDR EQU 0x8100				; adresa na kojoj se nalaze podatci
	MOV R4, #ADDR   		; postavlja R4 na pocetak podataka
	MOV R7, #8				; brojac hex znamenki = 8 
	MOV R6, #0				; resetiranje rezultata

PETLJA
	LDRB R0, [R4], #1	; ucitavanje ASCII-znaka
	BL FUNC_ATOH			; poziv potprograma za pretvorbu
	ADD R6, R0, R6, LSL #4	; spremanje rezultata u registar
									; (pomak trenutacnog rezultata za 
									; 4 bita)	
	SUBS R7, R7, #1		; brojac prolaza petlje
	BHI PETLJA	

KRAJ
	STR R6, [R4]			; spemanje rezultata

	MOV R0, #0x18			; angel_SWIreason_ReportException
	LDR R1, =0x20026 	; ADP_Stopped_ApplicationExit
	SWI 0x123456      	; ARM semihosting SWI


FUNC_ATOH		; potprogram za pretvorbu ASCII-znaka u HEX
				; ulazni ASCII-znak u R0
				; rezultat je takodjer u R0

	SUB R0, R0, #0x30	; ASCII:0 = HEX:30 
	CMP R0, #10				; ako je broj veci od 10 znaci
				; da se radi o slovu, predpostavlja
				; se da su ASCII-znakovi ispravni	
	MOVLO PC,LR				; povratak iz potprograma ako je R0<10

	SUB R0, R0, #7			; ASCII:A = HEX:41
	CMP R0, #16				; ako je broj veci od 16 znaci da
									; se radi o malom slovu
	MOVLO PC,LR				; povratak iz potprograma ako je R0<16

	SUB R0, R0, #0x20	; ASCII:a = HEX:61
	MOV PC,LR					; povratak iz potprograma

		
	END

